	
Notes2Window = class( Turbine.UI.Lotro.Window );

function Notes2Window:Constructor()

	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetBackColor( Turbine.UI.Color() );
	if Win_Mini then
		if current_type == 'account' then
			self:SetText( NN_account );
		else
			self:SetText( NN_char );
		end
		self:SetSize( Settings_Char.W, Settings_Char.H-diff);
		self:SetPosition( Settings_Char.X, Settings_Char.Y+diff);
		self:SetOpacity( Win_OC );
	else
		self:SetSize( Settings_Char.W, Settings_Char.H);
		self:SetPosition( Settings_Char.X, Settings_Char.Y);
		self:SetText( L["WINTitle"] );
		self:SetOpacity( 1 );
	end
	self:Activate();

	local Notes2 = self;
	local mainWindow = self;

	self.itemListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	self.itemListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	self.itemListBoxScrollBar:SetParent( self );

	self.itemNameBox = Turbine.UI.Lotro.TextBox();
	self.itemNameBox:SetFont( Turbine.UI.Lotro.Font.Verdana14 );
	self.itemNameBox:SetParent( self );
	self.itemNameBox:SetSize( 200, 20 );
	self.itemNameBox:SetPosition( 15, 55 );
	self.itemNameBox:SetVisible( false );
	
	accountComboBox = Wicky71Plugins.Notes2.ComboBox();
	accountComboBox:SetParent( self );
	accountComboBox:SetSize( 200, 20 );
	accountComboBox:SetPosition( 15, 55 );
	
	accountComboBox.ItemChanged = function ()
		NN_account = accountComboBox.label:GetText();
		AnzA_account = accountComboBox:GetSelection();
		self.noteLabel:SetText( L["WINLabel"]..AnzA_account.." / "..AnzM_account );
		self:NoteRefresh();
	end
	
	self.CreateAccountCB();
	
	charComboBox = Wicky71Plugins.Notes2.ComboBox();
	charComboBox:SetParent( self );
	charComboBox:SetSize( 200, 20 );
	charComboBox:SetPosition( 15, 55 );
	
	charComboBox.ItemChanged = function ()
		NN_char = charComboBox.label:GetText();
		AnzA_char = charComboBox:GetSelection();
		self.noteLabel:SetText( PN.." "..AnzA_char.." / "..AnzM_char );
		self:NoteRefresh();
	end
	
	self.CreateCharCB();
	
	self.itemListBox = Turbine.UI.Lotro.TextBox();
	self.itemListBox:SetFont( Turbine.UI.Lotro.Font.Verdana14 );
	self.itemListBox:SetParent( self );
	self.itemListBox:SetVerticalScrollBar( self.itemListBoxScrollBar );
	
	self.resizeHandle = Turbine.UI.Control();
	self.resizeHandle:SetParent( self );
	self.resizeHandle:SetZOrder( 100 );
	self.resizeHandle:SetSize( 20, 20 );
	self.resizeHandle:SetPosition( self:GetWidth() - self.resizeHandle:GetWidth(), self:GetHeight() - self.resizeHandle:GetHeight() );

	self.resizeHandle.MouseDown = function( sender, args )
		sender.dragStartX = args.X;
		sender.dragStartY = args.Y;
		sender.dragging = true;
		accountComboBox.dropDownWindow:SetVisible(false);
		charComboBox.dropDownWindow:SetVisible(false);
	end

	self.resizeHandle.MouseMove = function( sender, args )
		local displayWidth, displayHeight = Turbine.UI.Display.GetSize();
		local minWidth =360;
		local minHeight =150;
		local width, height = mainWindow:GetSize();
		local winX, winY = self:GetPosition();
		local tmpwidth = 0;
		local tmpheight = 0;
		
		if ( sender.dragging ) then
			if (width+(args.X-sender.dragStartX)>=minWidth and width+(args.X-sender.dragStartX)<=displayWidth-winX) then
				tmpwidth=width+(args.X-sender.dragStartX);
			elseif (width+(args.X-sender.dragStartX)<minWidth) then
				tmpwidth=minWidth;
			else
				tmpwidth=displayWidth-winX;
			end
	
			if (height+(args.Y-sender.dragStartY)>=minHeight and height+(args.Y-sender.dragStartY)<=displayHeight-winY) then
				tmpheight=height+(args.Y-sender.dragStartY);
			elseif (height+(args.Y-sender.dragStartY)<minHeight) then
				tmpheight=minHeight;
			else
				tmpheight=displayHeight-winY;
			end
			
			mainWindow:SetSize( tmpwidth, tmpheight);
			sender:SetPosition( mainWindow:GetWidth() - sender:GetWidth(), mainWindow:GetHeight() - sender:GetHeight() )
		end
		Notes2:PerformLayout()
	end

	self.resizeHandle.MouseUp = function( sender, args )
		sender.dragging = false;
	end

	self.Closed = function( sender, args )
		accountComboBox.dropDownWindow:SetVisible(false);
		charComboBox.dropDownWindow:SetVisible(false);
		self:SetWantsKeyEvents( false );
	end
	
	self.MouseClick = function ( sender, args )
		if (args.Button == Turbine.UI.MouseButton.Right) and not isNew then
			self.noteLabel:SetVisible( not self.noteLabel:IsVisible() );
			self.safeButton:SetVisible( not self.safeButton:IsVisible() );
			self.newButton:SetVisible( not self.newButton:IsVisible() );
			self.delButton:SetVisible( not self.delButton:IsVisible() );
			self.optionButton:SetVisible( not self.optionButton:IsVisible() );
			self.charButton:SetVisible( not self.charButton:IsVisible() );
			self.accountButton:SetVisible( not self.accountButton:IsVisible() );
			if current_type == 'account' then
				accountComboBox:SetVisible( not accountComboBox:IsVisible() );
			else
				charComboBox:SetVisible( not charComboBox:IsVisible() );
			end
			if self.noteLabel:IsVisible() then
				self:SetText( L["WINTitle"] );
				self:SetOpacity( 1 );
				mainWindow:SetSize( mainWindow:GetWidth(), mainWindow:GetHeight()+diff);
				mainWindow:SetPosition( mainWindow:GetLeft(), mainWindow:GetTop()-diff )
			else
				if current_type == 'account' then
					self:SetText( NN_account );
				else
					self:SetText( NN_char );
				end
				self:SetOpacity( Win_OC );
				mainWindow:SetSize( mainWindow:GetWidth(), mainWindow:GetHeight()-diff);
				mainWindow:SetPosition( mainWindow:GetLeft(), mainWindow:GetTop()+diff )
			end
			Notes2:PerformLayout()
		elseif isNew then
			Turbine.Shell.WriteLine( L["MSGErr3"] );
		end
	end
	
-- close by ESC, toggle by F12
	self.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			self:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then
			self:SetVisible( not self:IsVisible() );
			accountComboBox.dropDownWindow:SetVisible(false);
			charComboBox.dropDownWindow:SetVisible(false);
		end
	end

	self.MouseMove = function( sender, args )
		if dragging then if accountComboBox.dropped then accountComboBox:CloseDropDown(); end end
		if dragging then if charComboBox.dropped then charComboBox:CloseDropDown(); end end
	end

	self.noteLabel = Turbine.UI.Label();
	self.noteLabel:SetParent( self );
	self.noteLabel:SetPosition( 20, 40 );
	self.noteLabel:SetSize(260, 20 );
	self.noteLabel:SetVisible( not Win_Mini );
	
	self.charButton = Turbine.UI.Lotro.Button();
	self.charButton:SetParent( self );
	self.charButton:SetSize( 40, 20 );
	self.charButton:SetText( L["BTNCharacter"] );
	self.charButton:SetPosition( 260, 35 );
	self.charButton:SetVisible( not Win_Mini );
	
	self.accountButton = Turbine.UI.Lotro.Button();
	self.accountButton:SetParent( self );
	self.accountButton:SetSize( 40, 20 );
	self.accountButton:SetText( L["BTNAccount"] );
	self.accountButton:SetPosition( 220, 35 );
	self.accountButton:SetVisible( not Win_Mini );

	self.optionButton = Turbine.UI.Lotro.Button();
	self.optionButton:SetParent( self );
	self.optionButton:SetSize( 40, 20 );
	self.optionButton:SetText( L["BTNOption"] );
	self.optionButton:SetPosition( 300, 35 );
	self.optionButton:SetVisible( not Win_Mini );
	
	self.safeButton = Turbine.UI.Lotro.Button();
	self.safeButton:SetParent( self );
	self.safeButton:SetSize( 40, 20 );
	self.safeButton:SetText( L["BTNSave"] );
	self.safeButton:SetPosition( 220, 55 );
	self.safeButton:SetVisible( not Win_Mini );
	
	self.newButton = Turbine.UI.Lotro.Button();
	self.newButton:SetParent( self );
	self.newButton:SetSize( 40, 20 );
	self.newButton:SetText( L["BTNNew"] );
	self.newButton:SetPosition( 260, 55 );
	self.newButton:SetVisible( not Win_Mini );
	
	self.delButton = Turbine.UI.Lotro.Button();
	self.delButton:SetParent( self );
	self.delButton:SetSize( 40, 20 );
	self.delButton:SetText( L["BTNDelete"] );
	self.delButton:SetPosition( 300, 55 );
	self.delButton:SetVisible( not Win_Mini );
		
	self.TTlabel = Turbine.UI.Label();
	self.TTlabel:SetParent( self );
	self.TTlabel:SetVisible( false );
	self.TTlabel:SetFont( Turbine.UI.Lotro.Font.Verdana13 );
	self.TTlabel:SetTextAlignment( Turbine.UI.ContentAlignment.BottomLeft );
	self.TTlabel:SetForeColor( Turbine.UI.Color( 1, 1, 0 ) );
	self.TTlabel:SetSize(300, 15 );
	self.TTlabel:SetVisible( not Win_Mini );

	if current_type == 'account' then
		self.noteLabel:SetText( L["WINLabel"]..AnzA_account.." / "..AnzM_account );
		self.charButton:SetEnabled( true );
		self.accountButton:SetEnabled( false );
		charComboBox:SetVisible ( false );
		accountComboBox:SetVisible ( not Win_Mini );
	else
		self.noteLabel:SetText( PN.." "..AnzA_char.." / "..AnzM_char );
		self.charButton:SetEnabled( false );
		self.accountButton:SetEnabled( true );
		charComboBox:SetVisible ( not Win_Mini );
		accountComboBox:SetVisible ( false );
	end
	
	self.charButton.Click = function( sender, args )
		current_type = 'character';
		self:NoteRefresh();
		self.noteLabel:SetText( PN.." "..AnzA_char.." / "..AnzM_char );
		self.charButton:SetEnabled( false );
		self.accountButton:SetEnabled( true );
		charComboBox:SetVisible ( true );
		accountComboBox:SetVisible ( false );
		isNew = false;
		self.itemNameBox:SetVisible( false );
		accountComboBox.dropDownWindow:SetVisible(false);
		self.CreateCharCB();
	end
	
	self.charButton.MouseHover = function( sender, args )
		self.TTlabel:SetText(L["TTCharacter"]);
		self.TTlabel:SetVisible( TT_show );
	end
	
	self.charButton.MouseLeave = function( sender, args )
		self.TTlabel:SetVisible( false );
	end
			
	self.accountButton.Click = function( sender, args )
		current_type = 'account';
		self:NoteRefresh();
		self.noteLabel:SetText( L["WINLabel"]..AnzA_account.." / "..AnzM_account );
		self.charButton:SetEnabled( true );
		self.accountButton:SetEnabled( false );
		charComboBox:SetVisible ( false );
		accountComboBox:SetVisible ( true );
		isNew = false;
		self.itemNameBox:SetVisible( false );
		charComboBox.dropDownWindow:SetVisible(false);
		self.CreateAccountCB();
	end
	
	self.accountButton.MouseHover = function( sender, args )
		self.TTlabel:SetText(L["TTAccount"]);
		self.TTlabel:SetVisible( TT_show );
	end
	
	self.accountButton.MouseLeave = function( sender, args )
		self.TTlabel:SetVisible( false );
	end

	self.optionButton.Click = function( sender, args )
		Turbine.PluginManager.ShowOptions(Plugins["SimplyNotes"]);
	end

	self.optionButton.MouseHover = function( sender, args )
		self.TTlabel:SetText(L["TTOption"]);
		self.TTlabel:SetVisible( TT_show );
	end
	
	self.optionButton.MouseLeave = function( sender, args )
		self.TTlabel:SetVisible( false );
	end

	self.safeButton.Click = function( sender, args )
		if isNew then 
			local NN = self.itemNameBox:GetText();
			if current_type == 'account' and NN ~= L["WINNew"] then
				Notes_Acc[NN] = self.itemListBox:GetText();
				NN_account = NN;
				isNew = false;
				self.CreateAccountCB();			
				self.noteLabel:SetText( L["WINLabel"]..AnzA_account.." / "..AnzM_account );							
				accountComboBox:SetVisible( true );
				self.itemNameBox:SetVisible( false );
			elseif current_type == 'character' and NN ~= L["WINNew"] then
				Notes_Char[NN] = self.itemListBox:GetText();
				NN_char = NN;
				isNew = false;
				self.CreateCharCB();
				self.noteLabel:SetText( PN.." "..AnzA_char.." / "..AnzM_char );				
				charComboBox:SetVisible( true );
				self.itemNameBox:SetVisible( false );
			else
				Turbine.Shell.WriteLine( L["MSGErr1"] );
			end
		else
			if current_type == 'account' then
				Notes_Acc[NN_account] = self.itemListBox:GetText();
			else
				Notes_Char[NN_char] = self.itemListBox:GetText();
			end
		end
		SaveNote();
	end
	
	self.safeButton.MouseHover = function( sender, args )
		self.TTlabel:SetText(L["TTSave"]);
		self.TTlabel:SetVisible( TT_show );
	end
	
	self.safeButton.MouseLeave = function( sender, args )
		self.TTlabel:SetVisible( false );
	end
	
	self.newButton.Click = function( sender, args )
		self.itemNameBox:SetVisible( true );
		self.itemNameBox:SetText( L["WINNew"] );
		accountComboBox:SetVisible( false );
		charComboBox:SetVisible( false );
		isNew = true;
		self.itemListBox:SetText( L["MSG1"] );
	end

	self.newButton.MouseHover = function( sender, args )
		self.TTlabel:SetText(L["TTNew"]);
		self.TTlabel:SetVisible( TT_show );
	end
	
	self.newButton.MouseLeave = function( sender, args )
		self.TTlabel:SetVisible( false );
	end
	
	self.delButton.Click = function( sender, args )
		if current_type == 'account' then		
			accountComboBox:RemoveItem( accountComboBox:GetSelection() );
			self:DelNote();
			self.noteLabel:SetText( L["WINLabel"]..AnzA_account.." / "..AnzM_account );
		elseif current_type == 'character' then
			charComboBox:RemoveItem( charComboBox:GetSelection() );
			self:DelNote();
			self.noteLabel:SetText( PN.." "..AnzA_char.." / "..AnzM_char );
		end
		SaveNote();
	end
	
	self.delButton.MouseHover = function( sender, args )
		self.TTlabel:SetText(L["TTDelete"]);
		self.TTlabel:SetVisible( TT_show );
	end
	
	self.delButton.MouseLeave = function( sender, args )
		self.TTlabel:SetVisible( false );
	end	
	
	self:Refresh();
	self:NoteRefresh();
end

function Notes2Window:Refresh()
	self:PerformLayout();
end

function Notes2Window:PerformLayout()
	self:Layout( { } );
end

function Notes2Window:Layout( args )
	local width, height = self:GetSize();
	
	local listWidth = width - 30;
	local listHeight = height - 100;
	local tmpdiff = 0;
	
	if not self.noteLabel:IsVisible() then
		tmpdiff = diff;	
	end
	
	self.itemListBox:SetPosition( 15, 78-tmpdiff );
	self.itemListBox:SetSize( listWidth, listHeight+tmpdiff );
	
	self.itemListBoxScrollBar:SetPosition( width - 15, 78-tmpdiff );
	self.itemListBoxScrollBar:SetSize( 10, listHeight+tmpdiff );
	
	self.TTlabel:SetPosition(30, height-23 );
end

function Notes2Window:CreateAccountCB()
	local newt = {}
	for i in pairs(Notes_Acc) do
		if string.sub( i, 1, 1 ) == "~" then Notes_Acc[i] = nil; else table.insert(newt, i); end
	end
	table.sort(newt);
	AnzM_account = table.maxn(newt);
	accountComboBox.listBox:ClearItems();
	for k,v in pairs(newt) do
		accountComboBox:AddItem(v, k);
		if v == NN_account then accountComboBox:SetSelection(k); end
	end
	if AnzM_account > 0 and accountComboBox:GetSelection()~= nil then
		AnzA_account = accountComboBox:GetSelection();
	elseif AnzM_account > 0 and accountComboBox:GetSelection()== nil then
		AnzA_account = 1;
		accountComboBox:SetSelection(1);
		NN_account = accountComboBox.label:GetText();
	else
		AnzA_account = 0;
		accountComboBox.label:SetText(L["WINNew"]);
	end
end

function Notes2Window:CreateCharCB()
	local newt = {}
	for i in pairs(Notes_Char) do
		if string.sub( i, 1, 1 ) == "~" then Notes_Char[i] = nil; else table.insert(newt, i); end
	end
	table.sort(newt);
	AnzM_char = table.maxn(newt);
	charComboBox.listBox:ClearItems();
	for k,v in pairs(newt) do
		charComboBox:AddItem(v, k);
		if v == NN_char then charComboBox:SetSelection(k); end
	end
	if AnzM_char > 0 and charComboBox:GetSelection()~=nil then
		AnzA_char = charComboBox:GetSelection();
	elseif AnzM_char > 0 and charComboBox:GetSelection()==nil then
		AnzA_char = 1;
		charComboBox:SetSelection(1);
		NN_char = charComboBox.label:GetText();
	else
	 AnzA_char = 0;
	 charComboBox.label:SetText(L["WINNew"]);
	end
end

function Notes2Window:NoteRefresh()
	self:NoteLayout();
end

function Notes2Window:NoteLayout()
	self:UpdateNote( { } );
end

function Notes2Window:UpdateNote( args )
	if current_type == 'account' then
		if Notes_Acc[NN_account] == nil then
			self.itemListBox:SetText( L["MSG2"] );
		else
			self.itemListBox:SetText( Notes_Acc[NN_account] );
		end
	else
		if Notes_Char[NN_char] == nil then
			self.itemListBox:SetText( L["MSG2"] );
		else
			self.itemListBox:SetText( Notes_Char[NN_char] );
		end
	end
end

function Notes2Window:DelNote()
	local Tmp_Name = {}
	local Tmp_Text = {}
	
	if current_type == 'account' then
		for i in pairs(Notes_Acc) do
			if string.sub( i, 1, 1 ) == "~" then 
				Notes_Acc[i] = nil;
			else
				if i ~= NN_account then
					table.insert(Tmp_Name, i);
					table.insert(Tmp_Text, Notes_Acc[i]);
				end
			end
		end	
		Notes_Acc = { };
		for i = 1, table.maxn(Tmp_Name), 1 do
			Notes_Acc[Tmp_Name[i]] = Tmp_Text[i];
		end
	else
		for i in pairs(Notes_Char) do
			if string.sub( i, 1, 1 ) == "~" then 
				Notes_Char[i] = nil;
			else
				if i ~= NN_char then
					table.insert(Tmp_Name, i);
					table.insert(Tmp_Text, Notes_Char[i]);
				end
			end
		end	
		Notes_Char = { };
		for i = 1, table.maxn(Tmp_Name), 1 do
			Notes_Char[Tmp_Name[i]] = Tmp_Text[i];
		end		
	end
end