-- Options
optionsPanel = Turbine.UI.Control();
optionsPanel:SetSize( 300, 400 );

local width = 280;
local height = 20;
local Left = 10;

local BTN_Psave = Turbine.UI.Lotro.Button();
BTN_Psave:SetText( L["BSavePos"] );
BTN_Psave:SetSize( 250, height );
BTN_Psave:SetPosition( Left+20, 190 );
BTN_Psave:SetParent( optionsPanel );
BTN_Psave:SetEnabled( false );

local BTN_Ssave = Turbine.UI.Lotro.Button();
BTN_Ssave:SetText( L["BSaveSize"] );
BTN_Ssave:SetSize( 250, height );
BTN_Ssave:SetPosition( Left+20, 230 );
BTN_Ssave:SetParent( optionsPanel );
BTN_Ssave:SetEnabled( false );

local label1 = Turbine.UI.Label();
label1:SetText( L["LBL1"] );
label1:SetSize( width, height+5 );
label1:SetPosition( Left, 5 );
label1:SetParent( optionsPanel );
label1:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );


local CB_TT = Turbine.UI.Lotro.CheckBox();
CB_TT:SetText( L["CBTT"] );
CB_TT:SetSize( width, height );
CB_TT:SetPosition( Left, 30 );
CB_TT:SetParent( optionsPanel );
CB_TT:SetChecked(TT_show);

CB_TT.CheckedChanged = function(sender, args)
	Update(true);
end

local SBlabel = Turbine.UI.Label();
SBlabel:SetText( L["LBLopacity"] );
SBlabel:SetSize( width, height );
SBlabel:SetPosition( Left, 55 );
SBlabel:SetParent( optionsPanel );

local SBopacity = Turbine.UI.Lotro.ScrollBar();
SBopacity:SetSize( width, 10 );
SBopacity:SetPosition( Left, 70 );
SBopacity:SetParent( optionsPanel );
SBopacity:SetMinimum( 0 );
SBopacity:SetMaximum( 1000 );
SBopacity:SetValue( Win_OC*1000 );
SBopacity:SetOrientation( Turbine.UI.Orientation.Horizontal );

SBopacity.ValueChanged = function( sender, args )
	Notes2:SetOpacity( SBopacity:GetValue() / 1000 );
	Update(true);
end

local label2 = Turbine.UI.Label();
label2:SetText( L["LBL2"] );
label2:SetSize( width, height+5 );
label2:SetPosition( Left, 105 );
label2:SetParent( optionsPanel );
label2:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );

local CB_Visi = Turbine.UI.Lotro.CheckBox();
CB_Visi:SetText( L["CBVisi"] );
CB_Visi:SetSize( width, height );
CB_Visi:SetPosition( Left, 130 );
CB_Visi:SetParent( optionsPanel );
CB_Visi:SetChecked(Win_Visi);

CB_Visi.CheckedChanged = function(sender, args)
	Update(true);
end

local CB_Mini = Turbine.UI.Lotro.CheckBox();
CB_Mini:SetText( L["CBMini"] );
CB_Mini:SetSize( width, height );
CB_Mini:SetPosition( Left, 150 );
CB_Mini:SetParent( optionsPanel );
CB_Mini:SetChecked(Win_Mini);

CB_Mini.CheckedChanged = function(sender, args)
	Update(true);
end

local CB_FixPos = Turbine.UI.Lotro.CheckBox();
CB_FixPos:SetText( L["CBFixPos"] );
CB_FixPos:SetSize( width, height );
CB_FixPos:SetPosition( Left, 170 );
CB_FixPos:SetParent( optionsPanel );
CB_FixPos:SetChecked(Win_FixPos);

CB_FixPos.CheckedChanged = function(sender, args)
	if CB_FixPos:IsChecked() then
		BTN_Psave:SetEnabled( true );
	else
		BTN_Psave:SetEnabled( false );
	end;
	Update(true);
end

local CB_FixSize = Turbine.UI.Lotro.CheckBox();
CB_FixSize:SetText( L["CBFixSize"] );
CB_FixSize:SetSize( width, height );
CB_FixSize:SetPosition( Left, 210 );
CB_FixSize:SetParent( optionsPanel );
CB_FixSize:SetChecked(Win_FixSize);

CB_FixSize.CheckedChanged = function(sender, args)
	if CB_FixSize:IsChecked() then
		BTN_Ssave:SetEnabled( true );
	else
		BTN_Ssave:SetEnabled( false );
	end;
	Update(true);
end

local BTN_save = Turbine.UI.Lotro.Button();
BTN_save:SetText( L["BSave"] );
BTN_save:SetSize( 150, height );
BTN_save:SetPosition( Left, 320 );
BTN_save:SetParent( optionsPanel );
BTN_save:SetEnabled( false );

BTN_save.Click = function( sender, args )
 	TT_show = CB_TT:IsChecked();
 	Win_Visi = CB_Visi:IsChecked();
 	Win_Mini = CB_Mini:IsChecked();
 	Win_FixPos = CB_FixPos:IsChecked();
 	BTN_Psave:SetEnabled( false );
  Win_FixSize = CB_FixSize:IsChecked();
 	BTN_Ssave:SetEnabled( false );
 	Win_OC = SBopacity:GetValue() / 1000;
 	if Notes2.noteLabel:IsVisible() then Notes2:SetOpacity(1); end;
 	
 	Update(false);
 	
 	SaveSettings();
end

BTN_Psave.Click = function( sender, args )
	local PosX, PosY = Notes2:GetPosition();
	if Notes2.noteLabel:IsVisible() then
		WinY = PosY;
	else
		WinY = PosY-diff;
	end;
	WinX = PosX;
end

BTN_Ssave.Click = function( sender, args )
	local width, height = Notes2:GetSize();
	WinW = width;
	if Notes2.noteLabel:IsVisible() then
		WinH = height;
	else
		WinH = height+diff;
	end
end

function Update(data)
	BTN_save:SetEnabled( data );
end
