-- LOAD SETTINGS
function LoadSettings()
	Settings_Char = Turbine.PluginData.Load( Turbine.DataScope.Character, "Notes_Settings" );

	if Settings_Char == nil then Settings_Char = {}; end
	if Settings_Char.W == nil then Settings_Char.W = string.format("%.0f", 360); end
	if Settings_Char.H == nil then Settings_Char.H = string.format("%.0f", 150); end
	if Settings_Char.X == nil then Settings_Char.X = string.format("%.0f", 20); end
	if Settings_Char.Y == nil then Settings_Char.Y = string.format("%.0f", 200); end
	if Settings_Char.T == nil then Settings_Char.T = 'account'; end
	if Settings_Char.N == nil then Settings_Char.N = L["WINNew"]; end
	if Settings_Char.TT == nil then Settings_Char.TT = true; end
	if Settings_Char.V == nil then Settings_Char.V = true; end
	if Settings_Char.FP == nil then Settings_Char.FP = false; end
	if Settings_Char.XF == nil then Settings_Char.XF = string.format("%.0f", 20); end
	if Settings_Char.YF == nil then Settings_Char.YF = string.format("%.0f", 200); end
	if Settings_Char.FS == nil then Settings_Char.FS = false; end
	if Settings_Char.WF == nil then Settings_Char.WF = string.format("%.0f", 360); end
	if Settings_Char.HF == nil then Settings_Char.HF = string.format("%.0f", 150); end
	if Settings_Char.M == nil then Settings_Char.M = false; end
	if Settings_Char.O == nil then Settings_Char.O = string.format("%.3f", 0.5); end
	
	NN_char = Settings_Char.N;
	current_type = Settings_Char.T;
	TT_show = Settings_Char.TT;
	Win_Visi = Settings_Char.V;
	Win_FixPos = Settings_Char.FP;
	WinX = Settings_Char.XF;
	WinY = Settings_Char.YF;
	Win_FixSize = Settings_Char.FS;
	WinW = Settings_Char.WF;
	WinH = Settings_Char.HF;
	Win_Mini = Settings_Char.M;
	Win_OC = Settings_Char.O;
	
	if Win_FixPos then
		Settings_Char.X = WinX;
		Settings_Char.Y = WinY;
	end;
		if Win_FixSize then
		Settings_Char.W = WinW;
		Settings_Char.H = WinH;
	end;

-- workaround older versions ********
	if TT_show=='true' then 
		TT_show=true;
	elseif TT_show=='false' then
		TT_show=false;
	end;
--***********************************


	Settings_Acc = Turbine.PluginData.Load( Turbine.DataScope.Account, "Notes_Settings" );
	
	if Settings_Acc == nil then Settings_Acc = {}; end
	if Settings_Acc.N == nil then Settings_Acc.N = L["WINNew"]; end
	
	NN_account = Settings_Acc.N;

end

-- SAVE SETTINGS
function SaveSettings()

	local width, height = Notes2:GetSize();
	local PosX, PosY = Notes2:GetPosition();

  Settings_Char = {};
	Settings_Char.W = string.format("%.0f",width);
	if Notes2.noteLabel:IsVisible() then
		Settings_Char.H = string.format("%.0f",height);
		Settings_Char.Y = string.format("%.0f",PosY);
	else
		Settings_Char.H = string.format("%.0f",height+diff);
		Settings_Char.Y = string.format("%.0f",PosY-diff);
	end
	Settings_Char.X = string.format("%.0f",PosX);
	Settings_Char.T = current_type;
	Settings_Char.N = NN_char;
	Settings_Char.TT = TT_show;
	Settings_Char.V = Win_Visi;
	Settings_Char.FP = Win_FixPos;
	Settings_Char.XF = string.format("%.0f", WinX);
	Settings_Char.YF = string.format("%.0f", WinY);
	Settings_Char.FS = Win_FixSize;
	Settings_Char.WF = string.format("%.0f", WinW);
	Settings_Char.HF = string.format("%.0f", WinH);
	Settings_Char.M = Win_Mini;
	Settings_Char.O = string.format("%.3f", Win_OC);
	
	Turbine.PluginData.Save( Turbine.DataScope.Character, "Notes_Settings", Settings_Char );
	
	Settings_Acc ={};
	Settings_Acc.N = NN_account;
	
	Turbine.PluginData.Save( Turbine.DataScope.Account, "Notes_Settings", Settings_Acc );
end

-- LOAD THE NOTE DATA
function LoadNote()
	Notes_Char = Turbine.PluginData.Load( Turbine.DataScope.Character, "Notes" );

	if Notes_Char == nil then Notes_Char = { }; end
	
	Notes_Acc = Turbine.PluginData.Load( Turbine.DataScope.Account, "Notes" );

	if Notes_Acc == nil then Notes_Acc = { }; end
end

-- SAVE THE NOTE DATA
function SaveNote()
	if(current_type == 'character') then	
		Turbine.PluginData.Save( Turbine.DataScope.Character, "Notes", Notes_Char );
	elseif(current_type == 'account') then
		Turbine.PluginData.Save( Turbine.DataScope.Account, "Notes", Notes_Acc );
	else
		Turbine.Shell.WriteLine( L["MSGErr2"] );
	end
end

